﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Windows.Forms;
using Telerik.WinControls.UI;
using Telerik.WinControls.RadControlSpy;

namespace RowStateSelection
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        DataTable customers, orders, employees;
        DataSet dataSet;
        private void Form1_Load(object sender, EventArgs e)
        {
            new RadControlSpyForm().Show();

            this.radGridView1.AutoGenerateHierarchy = true;
            customers = new DataTable();
            customers.Columns.Add("CustomerID", typeof(Int32));
            customers.Columns.Add("CustomerName", typeof(String));
            customers.Rows.Add(1, "Mike");
            customers.Rows.Add(2, "Peter");
            customers.Rows.Add(3, "George");
            customers.Rows.Add(4, "Monica");
            customers.Rows.Add(5, "Nancy");

            orders = new DataTable();
            orders.Columns.Add("OrderID", typeof(Int32));
            orders.Columns.Add("CustomerID", typeof(Int32));
            orders.Columns.Add("EmployeeID", typeof(Int32));
            orders.Columns.Add("OrdersDetails", typeof(String));
            orders.Rows.Add(1001, 1, 1, "Order 1");
            orders.Rows.Add(1002, 1, 2, "Order 2");
            orders.Rows.Add(1003, 3, 3, "Order 3");
            orders.Rows.Add(1004, 2, 4, "Order 4");
            orders.Rows.Add(1005, 2, 1, "Order 5");
            orders.Rows.Add(1006, 2, 2, "Order 6");
            orders.Rows.Add(1007, 2, 3, "Order 7");
            orders.Rows.Add(1008, 3, 4, "Order 8");
            orders.Rows.Add(1009, 4, 1, "Order 9");
            orders.Rows.Add(1010, 4, 2, "Order 10");
            orders.Rows.Add(1011, 5, 3, "Order 11");
            orders.Rows.Add(1012, 5, 3, "Order 12");
            orders.Rows.Add(1013, 5, 4, "Order 13");

            employees = new DataTable();
            employees.Columns.Add("EmployeeID", typeof(Int32));
            employees.Columns.Add("EmployeeName", typeof(String));
            employees.Rows.Add(1, "Employee 1");
            employees.Rows.Add(2, "Employee 2");
            employees.Rows.Add(3, "Employee 3");
            employees.Rows.Add(4, "Employee 4");

            dataSet = new DataSet();
            dataSet.Tables.Add(customers);
            dataSet.Tables.Add(orders);
            dataSet.Tables.Add(employees);

            this.radGridView1.MasterTemplate.DataSource = customers;
            GridViewTemplate childTemplate1 = new GridViewTemplate();
            childTemplate1.DataSource = orders;
            this.radGridView1.Templates.Add(childTemplate1);
            
            GridViewRelation relation1 = new GridViewRelation(this.radGridView1.MasterTemplate, this.radGridView1.Templates[0]);
            System.Collections.Specialized.StringCollection parentField = new System.Collections.Specialized.StringCollection();
            parentField.Add("CustomerID");
            System.Collections.Specialized.StringCollection childField = new System.Collections.Specialized.StringCollection();
            childField.Add("CustomerID");
            relation1.ChildColumnNames = childField;
            relation1.ParentColumnNames = parentField;
            this.radGridView1.Relations.Add(relation1);

            GridViewTemplate childTemplate2 = new GridViewTemplate();
            childTemplate2.DataSource = employees;
            childTemplate1.Templates.Add(childTemplate2);

            GridViewRelation relation2 = new GridViewRelation(childTemplate1, childTemplate1.Templates[0]);
            System.Collections.Specialized.StringCollection parentField2 = new System.Collections.Specialized.StringCollection();
            parentField2.Add("EmployeeID");
            System.Collections.Specialized.StringCollection childField2 = new System.Collections.Specialized.StringCollection();
            childField2.Add("EmployeeID");
            relation2.ChildColumnNames = childField2;
            relation2.ParentColumnNames = parentField2;
            this.radGridView1.Relations.Add(relation2);

            childTemplate1.BestFitColumns();
            childTemplate2.BestFitColumns();
            this.radGridView1.MultiSelect = true;
        }

        HashSet<int> employeesExpandedRows = new HashSet<int>();
        HashSet<int> ordersExpandedRows = new HashSet<int>();
        
        HashSet<int> customersSelectedRows = new HashSet<int>();
        HashSet<int> ordersSelectedRows = new HashSet<int>();
        HashSet<int> employeesSelectedRows = new HashSet<int>();

        public void RestoreExpandedRows(GridViewTemplate template, string columnName, HashSet<int> set)
        {
            foreach (GridViewRowInfo row in template.Rows)
            {
                int id = (int)row.Cells[columnName].Value;
                if (set.Contains(id))
                {
                    row.IsExpanded = true;
                }
            }
        }

        public void SaveExpandedRow(GridViewTemplate template, string columnName, HashSet<int> set)
        {
            set.Clear();
            foreach (GridViewRowInfo row in template.Rows)
            {
                if (row.IsExpanded)
                {
                    int id = (int)row.Cells[columnName].Value;
                    set.Add(id);
                }
            }
        }

        public void FindSelectedRow(GridViewTemplate template, string columnName, HashSet<int> set)
        {
            set.Clear();
            foreach (GridViewRowInfo row in template.Rows)
            {
                if (row.IsSelected)
                {
                    int id = (int)row.Cells[columnName].Value;
                    set.Add(id);
                }
            }
        }

        public void RestoreSelectedRows(GridViewTemplate template, string columnName, HashSet<int> set)
        {
            foreach (GridViewRowInfo row in template.Rows)
            {
                int id = (int)row.Cells[columnName].Value;
                if (set.Contains(id))
                {
                    row.IsSelected = true;
                }
            }
        }

        private void radButton1_Click(object sender, EventArgs e)
        {
            FindSelectedRow(this.radGridView1.MasterTemplate, "CustomerID", customersSelectedRows);
            FindSelectedRow(this.radGridView1.Templates[0], "OrderID", ordersSelectedRows);
            FindSelectedRow(this.radGridView1.Templates[0].Templates[0], "EmployeeID", employeesSelectedRows);
            
            SaveExpandedRow(this.radGridView1.MasterTemplate, "CustomerID", employeesExpandedRows);
            SaveExpandedRow(this.radGridView1.Templates[0], "OrderID", ordersExpandedRows);
            
            this.dataSet.AcceptChanges();
            
            RestoreExpandedRows(this.radGridView1.MasterTemplate, "CustomerID", employeesExpandedRows);
            RestoreExpandedRows(this.radGridView1.Templates[0], "OrderID", ordersExpandedRows);

            RestoreSelectedRows(this.radGridView1.MasterTemplate, "CustomerID", customersSelectedRows);
            RestoreSelectedRows(this.radGridView1.Templates[0], "OrderID", ordersSelectedRows);
            RestoreSelectedRows(this.radGridView1.Templates[0].Templates[0], "EmployeeID", employeesSelectedRows);
        }
    }
}

